   subroutine trunk(n,h,f,rstart,rend)
      integer , intent(IN) :: n
      real*8,   intent(IN) :: h
      real*8,  intent(INOUT) :: f(1:n)
      real*8,  intent(IN) :: rstart,rend

      integer :: i
      real*8 :: r,pi,delta,arg

      pi=acos(-1.d0)
      delta=rend-rstart
      do i=1,n
        r=i*h
        if (r>rstart .and. r<=rend) then
           arg=pi*(r-rstart)/delta
           f(i)=f(i)*(sin(arg)/arg)**2
        endif
        if (r>rend) f(i)=0
      enddo
   end
        
        
       
      
